<template src="./recommended.htm"></template>

<script>

    import Vue from 'vue';
    import { breadcrumbsMixin } from '../../../mixins/breadcrumbsMixin.js';
    import AutocompleteComponent from '../../../inputs/AutocompleteComponent.vue';
    import ValidationErrorsMixin from '../../../mixins/validationErrorsMixin.js';
    import GetEntitiesMixin from '../../../mixins/entities/getEntitiesMixin.js';
    import draggable from 'vuedraggable';

    Vue.component('autocomplete-component', AutocompleteComponent);

    export default {

        mounted() {

            this.getRecommendedProducts();
        },

        data() {

            return {

                recommended_products: []
            }
        },

        mixins: [
            breadcrumbsMixin,
            ValidationErrorsMixin,
            GetEntitiesMixin
        ],

        components: {
            draggable
        },

        methods: {

            /**
             * Get recommended products.
             */
            getRecommendedProducts() {

                this.setEntityLoadingStatus('recommends', true);

                axios.get(route('admin.products.recommends.all'))

                    .then( (response) => this.recommended_products = response.data.data)

                    .catch( (errors) => parseResponseErrors(errors.response))

                    .then( () => this.setEntityLoadingStatus('recommends', false));
            },


            /**
             * Push selected value from autocomplete.
             *
             * @param value
             */
            pushToRecommendedProducts(value) {

                if (! this.recommended_products.find( (el) => el.id === value.id)) {

                    this.setEntityLoadingStatus('recommends', true);

                    axios.get(route('admin.products.recommends.add', value.id))

                        .then( (response) => {

                            toastr.success('Product successfully added!');

                            this.recommended_products.push(value);
                        })

                        .catch( (errors) => parseResponseErrors(errors.response, this))

                        .then( () => this.setEntityLoadingStatus('recommends', false));
                }
            },


            /**
             * Remove recommended product from array.
             *
             * @param index
             */
            removeRecommendedProduct(index) {

                this.setEntityLoadingStatus('recommends', true);

                axios.get(route('admin.products.recommends.remove', this.recommended_products[index].id))

                    .then( (response) => {

                        toastr.success('Product successfully removed!');

                        this.recommended_products.splice(index, 1);
                    })

                    .catch( (errors) => parseResponseErrors(errors.response, this))

                    .then( () => this.setEntityLoadingStatus('recommends', false));
            },


            /**
             * @param src
             * @return {*}
             */
            imageCacheRoute(src) {

                return route('images.cache', { template: 'small', filename: src });
            },


            /**
             * Reorder recommended products.
             */
            reorder() {

                this.setEntityLoadingStatus('reorder', true);

                this.recommended_products.forEach( (el, index) => {

                    this.recommended_products[index].position = index + 1;

                });

                let products = this.recommended_products.map( (el) => {

                    return {

                        id: el.id,
                        position: el.position
                    };
                });

                axios.post(route('admin.products.recommends.reorder'), createRequestObject({ recommended_products: products }))

                    .then( (response) => toastr.success('Successfully reordered products!'))

                    .catch( (errors) => parseResponseErrors(errors.response, this))

                    .then( () => this.setEntityLoadingStatus('reorder', false));
            }
        },

        computed: {

            /**
             * Options for drag transitions.
             *
             * @return {{animation: number, group: string, disabled: boolean, ghostClass: string}}
             */
            dragOptions() {

                return {
                    animation: 0,
                    group: "description",
                    disabled: false,
                    ghostClass: "ghost"
                };
            }
        }
    }

</script>